#include frex:shaders/api/context.glsl
#include frex:shaders/lib/bitwise.glsl

/******************************************************
  canvas:shaders/internal/flags.glsl
******************************************************/

#define _CV_FLAG_EMISSIVE           0// 1 for emissive material
#define _CV_FLAG_DISABLE_DIFFUSE    1// 1 if diffuse shade should not be applied
#define _CV_FLAG_DISABLE_AO         2// 1 if ao shade should not be applied
#define _CV_FLAG_CUTOUT             3// 1 if cutout layer - will only be set in base, non-translucent materials
#define _CV_FLAG_UNMIPPED           4// 1 if LOD disabled - only set in conjunction with cutout
#define _CV_FLAG_TRANSLUCENT_CUTOUT 5// 1 if low cutout threshold for translucency and particles (Yarn calls it 10, it's not actually 10%
#define _CV_FLAG_HURT_OVERLAY       6// 1 if should render red hurt overlay
#define _CV_FLAG_FLASH_OVERLAY      7// 1 if should render white flash overlay

#define _CV_TRANSLUCENT_CUTOUT_THRESHOLD 0.003921569

flat varying uint _cvv_flags;

float _cv_getFlag(int flagId) {
	return frx_bitValue(_cvv_flags, flagId);
}
